import * as _ from './common'
import GlobalProgressBar0 from './GlobalProgressBar0'
import GlobalProgressBar1 from './GlobalProgressBar1'

import config from './GlobalProgressBar.config'

export default {
  
  progressBarInstance: null,

  install(Vue, opts) {

    try {
      _.deepMerge(config, opts)
    } catch (e) {
      throw new Error('vue-simple-progressbar: configuration error, please refer to the complete configuration description.')
    }

    let globalProgressBarConstructor

    switch (config.mode) {
      case 0:
        globalProgressBarConstructor = Vue.extend(GlobalProgressBar0)
        break
      case 1:
        globalProgressBarConstructor = Vue.extend(GlobalProgressBar1)
        break
    }

    this.progressBarInstance = new globalProgressBarConstructor().$mount()
    document.body.appendChild(this.progressBarInstance.$el)

    const emit = eventName => this.progressBarInstance.$emit(eventName)

    Vue.$progress = Vue.prototype.$progress = {
      start: () => emit('start'),
      finish: () => emit('finish'),
      error: () => emit('errorFinish'),
      warning: () => emit('warningFinish'),
      success: () => emit('successFinish')
    }
  }

}